"use strict"

if (!net)
  var net = {}
  
if (!net.tschmid)
  net.tschmid = {};
  
if (!net.tschmid.sieve)
  net.tschmid.sieve = {};

if (!net.tschmid.sieve.editor)
  net.tschmid.sieve.editor = {};

if (!net.tschmid.sieve.editor.text)
  net.tschmid.sieve.editor.text = {};  
  
if (!net.tschmid.sieve.editor.text.glue)
  net.tschmid.sieve.editor.text.glue = {};  

  
(function() {

  function SieveTextEditorGlue(id) {  
  	this.glue = new net.tschmid.sieve.iframe.glue(id);
  	this.id = id;
  }
  
  SieveTextEditorGlue.prototype = {
  	
    glue : null,
    listener : null,
    callbacks : null,
    id : null,
    
    setListener : function(listener) {      
      this.listener = listener;
      
      var that = this;
      this.glue.setListener( function(event, data) { that.onMessage(event, data); });  	
    },
    
    
    onCallback : function(event, data) {
    	
      if (!this.callbacks)
        return;
      	
       if (!this.callbacks[event])
      	 return;
      	  
       if (!Array.isArray(this.callbacks[event]))
         return;
      	
       this.callbacks[event].forEach(
         function (element) { element(data); }
       );
       
       delete this.callbacks[event];      	
    },
    
    onListener : function(event, data) {
      
      if (!this.listener)
        return;
    
      if (event == "onChange")
        this.listener.onChange();
        
     /* if (event == "onGetScript")
        this.listener.onGetScript(data);*/
      
      if (event == "onActiveLineChange")
        this.listener.onActiveLineChange();
        
      if (event == "onStringFound")
        this.listener.onStringFound();    	
    },
    
    
    onMessage : function(event, data) {
      // we first handle call backs...
      this.onCallback(event,data);
      // and then the default listeners
      this.onListener(event,data);
    },
    
    addCallback : function(id, callback) {    
      
      if (!this.callbacks)
        this.callbacks = {};
      
      if (!this.callbacks[id])
        this.callbacks[id] = [];
        
      this.callbacks[id].push(callback);
    },
  
    loadScript : function(script, callback) {
      if (callback)
        this.addCallback("onScriptLoaded", callback);
    	
      this.glue.sendMessage("loadScript", script);
    },
    
    getScript : function(callback) 
    {
      if (callback)
        this.addCallback("onGetScript", callback);
        
      this.glue.sendMessage("getScript");
    },
  
    setScript : function(script) 
    {
  	  this.glue.sendMessage("setScript", script);
    },
    
    replaceSelection : function(text)
    {
      this.glue.sendMessage("replaceSelection",text);
    },
    
    selectAll : function()
    {
      this.glue.sendMessage("selectAll");
    },
    
    undo : function()
    {
      this.glue.sendMessage("undo");
    },
    
    redo : function()
    {
      this.glue.sendMessage("redo");
    },
    
    findString : function(token, isCaseSensitive, isReverse) 
    { 
      var data = {};
      data.token = token;
      data.isCaseSensitive = isCaseSensitive;
      data.isReverse = isReverse;
    	
      this.glue.sendMessage("findString", data);
    },
    
    replaceString : function(oldToken, newToken, isCaseSensitive, isReverse)
    {
      var data = {};
      data.oldToken = oldToken;
      data.newToken = newToken;
      data.isCaseSensitive = isCaseSensitive;
      data.isReverse = isReverse;
      
      this.glue.sendMessage("replaceString", data);
    },
    
    focus : function() {
      document.getElementById(this.id).focus();
      this.glue.sendMessage("focus");	      	
    }
    
  }    
  
  // Export the constructor...
  net.tschmid.sieve.editor.text.glue = SieveTextEditorGlue;
  
}());
  